#include "setup.lua"
#include "library.lua"

function initOptions()

    fadeKey = 0
    fadeKey2 = 0
    fadeKey3 = 0
    changeKey = {}
    slide = 0
    wheel = 0
    keybinds = true
    frame=0

end

function drawOptions()

    UiScale(0.7)

    local w = UiWidth()
    local h = UiHeight()

    UiColor(0.08, 0.08, 0.08)
    local bounds = {w,h}
    UiColor(1, 1, 1)
    local l,a = UiGetImageSize("MOD/options/Shape1.png")


    UiPush()
        if lights then
            UiTranslate(0, 15)
        end
        UiButtonImageBox("MOD/options/Shape4.png", 0, 0)
        UiTranslate(0, -30)
        UiAlign("left top")
        UiFont("regular.ttf", 37)
        light = UiTextButton(">>>>>>>>>>>>>>>>>>>>>>>>>>>>               LIGHTS/SOUNDS", 1050, 110)

        if light then
            UiSound("MOD/sound/click.ogg")
            keybinds = false
            lights = true    
            doors = false
        end
    UiPop()


    UiPush()
        if doors then
            UiTranslate(0, 15)
        end
        UiButtonImageBox("MOD/options/Shape3.png", 0, 0)
        UiTranslate(0, -30)
        UiAlign("left top")
        UiFont("regular.ttf", 37)
        door = UiTextButton(">>>>>>>>>>>>>>          DOOR OPTIONS", 730, 110)
        if door then
            UiSound("MOD/sound/click.ogg")
            keybinds = false
            lights = false    
            doors = true
        end
    UiPop()


    UiPush()
        if keybinds then
            UiTranslate(0, 15)
        end
        UiButtonImageBox("MOD/options/Shape2.png", 0, 0)
        UiTranslate(0, -30)
        UiAlign("left top")
        UiFont("regular.ttf", 37)
        bind = UiTextButton("KEY BINDS", 426, 110)

        if bind then
            UiSound("MOD/sound/click.ogg")
            keybinds = true
            lights = false   
            doors = false
        end
    UiPop()




    UiPush()
    if doors then
        UiTranslate(bounds[1]/20, 200)

        UiPush()
        UiButtonImageBox("MOD/options/box-1.png", 6, 6, 1, 1, 1)
        UiAlign("left top")
        if GetBool(pathUi.."HoldDoor")  then
            UiPush()
                UiColor(0.3, 0.8, 0.3)
                UiTranslate(-4, -4)
                UiImageBox("MOD/options/box-outline-8.png", 309, 59, 6, 6)
            UiPop()
        end
        UiColor(1, 1, 1)
        UiFont("regular.ttf", 30)
        holddoor = UiTextButton("Hold Door", 300, 50)
        UiTranslate(350,10)
        UiFont("regular.ttf", 30)
        UiText("Hold and drag to open the door")
        if holddoor then
            SetBool(pathUi.."HoldDoor", true)
            SetBool(pathUi.."ClickDoor", false)
            SetBool(pathUi.."Deactivatedoors", false)
        end
        UiPop()

        UiTranslate(0,100)

        UiPush()
        UiButtonImageBox("MOD/options/box-1.png", 6, 6, 1, 1, 1)
        UiAlign("left top")
        if GetBool(pathUi.."ClickDoor")  then
            UiPush()
                UiColor(0.3, 0.8, 0.3)
                UiTranslate(-4, -4)
                UiImageBox("MOD/options/box-outline-8.png", 309, 59, 6, 6)
            UiPop()
        end
        UiColor(1, 1, 1)
        UiFont("regular.ttf", 30)
        doorclick = UiTextButton("Click", 300, 50)
        UiTranslate(350,10)
        UiFont("regular.ttf", 30)
        UiText("Right click to open the door")
        if doorclick then
            SetBool(pathUi.."ClickDoor", true)
            SetBool(pathUi.."HoldDoor", false)
            SetBool(pathUi.."Deactivatedoors", false)
        end
        UiPop()

        UiTranslate(0,100)

        UiPush()
        UiButtonImageBox("MOD/options/box-1.png", 6, 6, 1, 1, 1)
        UiAlign("left top")
        if GetBool(pathUi.."OpenWhenExit")  then
            UiPush()
                UiColor(0.3, 0.8, 0.3)
                UiTranslate(-4, -4)
                UiImageBox("MOD/options/box-outline-8.png", 309, 59, 6, 6)
            UiPop()
        end
        UiColor(1, 1, 1)
        UiFont("regular.ttf", 30)
        autoclose = UiTextButton("enter/exit", 300, 50)
        UiTranslate(350,10)
        UiFont("regular.ttf", 30)
        UiText("Open and close drivers door when getting in and out of the vehicle")
        if autoclose and not GetBool(pathUi.."Deactivatedoors") then
            SetBool(pathUi.."OpenWhenExit", not GetBool(pathUi.."OpenWhenExit"))
        end
        UiPop()

        UiTranslate(0,100)

        UiPush()
        UiButtonImageBox("MOD/options/box-1.png", 6, 6, 1, 1, 1)
        UiAlign("left top")
        if GetBool(pathUi.."Deactivatedoors")  then
            UiPush()
                UiColor(0.3, 0.8, 0.3)
                UiTranslate(-4, -4)
                UiImageBox("MOD/options/box-outline-8.png", 309, 59, 6, 6)
            UiPop()
        end
        UiColor(1, 1, 1)
        UiFont("regular.ttf", 30)
        deactivate = UiTextButton("Deactivate", 300, 50)
        UiTranslate(350,10)
        UiFont("regular.ttf", 30)
        UiText("Deactivate the doors")
        if deactivate then
            SetBool(pathUi.."ClickDoor", false)
            SetBool(pathUi.."HoldDoor", false)
            SetBool(pathUi.."OpenWhenExit", false)
            SetBool(pathUi.."Deactivatedoors", true)
        end
        UiPop()

    --[[
        UiTranslate(0,100)

        UiPush()
        UiButtonImageBox("MOD/options/box-1.png", 6, 6, 1, 1, 1)
        UiAlign("left top")
        if GetBool(pathUi.."FPS")   then
            UiPush()
                UiColor(0.3, 0.8, 0.3)
                UiTranslate(-4, -4)
                UiImageBox("MOD/options/box-outline-8.png", 309, 59, 6, 6)
            UiPop()
        end
        UiColor(1, 1, 1)
        UiFont("regular.ttf", 30)
        fps = UiTextButton("Delete", 300, 50)
        UiTranslate(350,10)
        UiFont("regular.ttf", 30)
        UiText("When vehicle life reaches 0, deletes the vehicle")
        if fps then
            SetBool(pathUi.."FPS", not GetBool(pathUi.."FPS"))
        end
        UiPop()
    ]]--

        UiTranslate(0,100)

        UiPush()
        UiButtonImageBox("MOD/options/box-1.png", 6, 6, 1, 1, 1, 1)
        UiButtonPressDist(2)
        UiAlign("left top")
        UiColor(1, 1, 1)
        UiFont("regular.ttf", 40)
        resetButton = UiTextButton("Reset to default", 700, 60)
    
        if resetButton then
            showResetKey3 = true
            fadeKey3 = 0.7
            for i=1, #setupUiDoor do
                if setupUiDoor[i][2] == "bool" then
                    SetBool(pathUi..setupUiDoor[i][1], setupUiDoor[i][3])
                end
            end
        end
        UiPop()

        UiTranslate(200,100)

        if showResetKey3 then
            UiPush()
                SetValue("fadeKey3", 0, "easein", 5)
                UiColor(1, 1, 1, fadeKey3)
                UiFont("regular.ttf", 35)
                UiText("Settings Has Been Reset")
                if fadeKey3 == 0 then showResetKey3 = false end
            UiPop()
        end
    

    end
    UiPop()

    UiPush()
    if lights then
             
        SetFloat("lightsf", GetFloat(pathUi.."lightsf"))
        SetFloat("lightst", GetFloat(pathUi.."lightst"))
        SetFloat("HighBeam", GetFloat(pathUi.."HighBeam"))
        SetFloat("EmLights", GetFloat(pathUi.."EmLights"))
        SetString("emergency.menu", GetString(pathKey.."menu"))
        SetString("emergency.primary", GetString(pathKey.."primary"))
        SetString("emergency.secondary", GetString(pathKey.."secondary"))
        SetString("emergency.tertiary", GetString(pathKey.."tertiary"))
        SetString("emergency.directional", GetString(pathKey.."directional"))

        Lightsf = GetFloat(pathUi.."Lightsf")
        Lightst = GetFloat(pathUi.."Lightst")
        HighBeam = GetFloat(pathUi.."HighBeam")
        EmLights = GetFloat(pathUi.."EmLights")
        HornVolume = GetFloat(pathUi.."HornVolume")
        SirenVolume = GetFloat(pathUi.."SirenVolume")

        UiTranslate(bounds[1]/10, 240)   

        UiPush()
        
        UiPush()
        UiTranslate(-100, -35)
        UiImageBox("MOD/options/box-1.png", 300, 50, 6, 6)
        UiPop()
        UiPush()
        UiTranslate(-10, 0)
            UiColor(1, 1, 1)
            UiFont("regular.ttf", 30)
            UiText("Lights Front")
        UiPop()
            UiTranslate(250, 0)
            UiFont("regular.ttf", 30)
            UiColor(0.9, 0.9, 0.9)
            UiText(math.ceil(Lightsf/5)/10)
            UiTranslate(50, -10)
            Lightsf, slideDone = DrawSlider(Lightsf, 500, 0.2, 0.2, 0.2, 1, 1, 1)
            SetFloat(pathUi.."Lightsf", Lightsf)
        UiPop()

        UiTranslate(0, 100)
        UiPush()
        UiPush()
        UiTranslate(-100, -35)
        UiImageBox("MOD/options/box-1.png", 300, 50, 6, 6)
        UiPop()
        UiPush()
        UiTranslate(-10, 0)
            UiColor(1, 1, 1)
            UiFont("regular.ttf", 30)
            UiText("Lights Back")
        UiPop()
            UiTranslate(250, 0)
            UiFont("regular.ttf", 30)
            UiColor(0.9, 0.9, 0.9)
            UiText(math.ceil(Lightst/5)/10)
            UiTranslate(50, -10)
            Lightst, slideDone = DrawSlider(Lightst, 500, 0.2, 0.2, 0.2, 1, 1, 1)
            SetFloat(pathUi.."Lightst", Lightst)
        UiPop()

        UiTranslate(0, 100)
        UiPush()
        UiPush()
        UiTranslate(-100, -35)
        UiImageBox("MOD/options/box-1.png", 300, 50, 6, 6)
        UiPop()
        UiPush()
        UiTranslate(-10, 0)
            UiColor(1, 1, 1)
            UiFont("regular.ttf", 30)
            UiText("High Beam")
        UiPop()
            UiTranslate(250, 0)
            UiFont("regular.ttf", 30)
            UiColor(0.9, 0.9, 0.9)
            UiText(math.ceil(HighBeam/5)/10)
            UiTranslate(50, -10)
            HighBeam, slideDone = DrawSlider(HighBeam, 500, 0.2, 0.2, 0.2, 1, 1, 1)
            SetFloat(pathUi.."HighBeam", HighBeam)
        UiPop()

        UiTranslate(0, 100)
        UiPush()
        UiPush()
        UiTranslate(-100, -35)
        UiImageBox("MOD/options/box-1.png", 300, 50, 6, 6)
        UiPop()
        UiPush()
        UiTranslate(-45, 0)
            UiColor(1, 1, 1)
            UiFont("regular.ttf", 30)
            UiText("Emergency Lights")
        UiPop()
            UiTranslate(250, 0)
            UiFont("regular.ttf", 30)
            UiColor(0.9, 0.9, 0.9)
            UiText(math.ceil(EmLights/5)/10)
            UiTranslate(50, -10)
            EmLights, slideDone = DrawSlider(EmLights, 500, 0.2, 0.2, 0.2, 1, 1, 1)
            SetFloat(pathUi.."EmLights", EmLights)
        UiPop()

        UiTranslate(0, 100)
        UiPush()
        UiPush()
        UiTranslate(-100, -35)
        UiImageBox("MOD/options/box-1.png", 300, 50, 6, 6)
        UiPop()
        UiPush()
        UiTranslate(-25, 0)
            UiColor(1, 1, 1)
            UiFont("regular.ttf", 30)
            UiText("Horn Volume")
        UiPop()
                UiTranslate(250, 0)
                UiFont("regular.ttf", 30)
                UiColor(0.9, 0.9, 0.9)
                UiText(math.ceil(HornVolume/5)/100)
                UiTranslate(50, -10)
                HornVolume, slideDone = DrawSlider(HornVolume, 500, 0.2, 0.2, 0.2, 1, 1, 1)
                SetFloat(pathUi.."HornVolume", HornVolume)
        UiPop()

        UiTranslate(0, 100)
            UiPush()
        UiPush()
            UiTranslate(-100, -35)
            UiImageBox("MOD/options/box-1.png", 300, 50, 6, 6)
        UiPop()
        UiPush()
        UiTranslate(-25, 0)
            UiColor(1, 1, 1)
            UiFont("regular.ttf", 30)
            UiText("Sirens Volume")
        UiPop()
            UiTranslate(250, 0)
            UiFont("regular.ttf", 30)
            UiColor(0.9, 0.9, 0.9)
            UiText(math.ceil(SirenVolume/5)/100)
            UiTranslate(50, -10)
            SirenVolume, slideDone = DrawSlider(SirenVolume, 500, 0.2, 0.2, 0.2, 1, 1, 1)
            SetFloat(pathUi.."SirenVolume", SirenVolume)
        UiPop()

        UiTranslate(0, 100)

        UiPush()
        UiButtonImageBox("MOD/options/box-1.png", 6, 6, 1, 1, 1, 1)
        UiButtonPressDist(2)
        UiAlign("left top")
        UiColor(1, 1, 1)
        UiFont("regular.ttf", 40)
        resetButton = UiTextButton("Reset to default", 700, 60)
    
        if resetButton then
            showResetKey2 = true
            fadeKey2 = 0.7
            for i=1, #setupUiLights do
                if setupUiLights[i][2] == "float" then
                    SetFloat(pathUi..setupUiLights[i][1], setupUiLights[i][3])
                end
            end
        end
        UiPop()
        UiTranslate(200, 100)
        if showResetKey2 then
            UiPush()
                SetValue("fadeKey2", 0, "easein", 5)
                UiColor(1, 1, 1, fadeKey2)
                UiFont("regular.ttf", 35)
                UiText("Settings Has Been Reset")
                if fadeKey2 == 0 then showResetKey2 = false end
            UiPop()
        end


    end
    UiPop()

    if keybinds then
        --key bindis
        UiPush()
            UiAlign("center middle")
            UiPush()
            UiTranslate(bounds[1]/6, 150)
                for i=1, #KeyList do
                    if KeyList[i][1] == "Basic Control" or KeyList[i][1] == "Emergency Lights" or KeyList[i][1] == "Sounds" then
                        UiTranslate(0, 30)
                        UiPush()
                            UiFont("regular.ttf", 50)
                            UiColor(1, 1, 1)
                            UiText(KeyList[i][2])
                        UiPop()
                    else  
                        UiPush()
                            UiTranslate(-50, 0)
                            UiImageBox("MOD/options/box-1.png", 400, 48, 6, 6)
                            UiFont("regular.ttf", 30)
                            UiColor(1, 1, 1)
                            UiText(KeyList[i][1])                       
                        UiPop()
                        UiPush()
                            UiTranslate(200, 0)
                            KeyList[i][2] = GetString(pathKey..KeyList[i][3])
                            if KeyList[i][2] ~= "" then
                                keyDisplay = KeyList[i][2]
                            else
                                keyDisplay = "None"
                            end
                            change, changeKey[i] = DrawChangeButton(changeKey[i], keyDisplay, 100, 48, "regular.ttf", 30, 1, 1, 1)
                            if changeKey[i] then 
                                if InputLastPressedKey() == "tab" or InputLastPressedKey() == "esc" then
                                    changeKey[i] = false
                                else
                                    if InputPressed(",") then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], ",")
                                    elseif InputPressed(".") then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], ".")
                                    elseif InputPressed("-") then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], "-")
                                    elseif InputPressed("+") then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], "+")
                                    elseif InputPressed("lmb") then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], "LMB")
                                    elseif InputPressed("rmb") then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], "RMB")
                                    elseif InputPressed("mmb") then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], "MMB")
                                    elseif InputLastPressedKey() ~= "" then
                                        changeKey[i] = false
                                        SetString(pathKey..KeyList[i][3], InputLastPressedKey())
                                    end
                                    KeyList[i] = {KeyList[i][1], GetString(pathKey..KeyList[i][3]), KeyList[i][3]}
                                    n = 0
                                    sameKey = false
                                    repeat
                                        n = n + 1
                                        if n ~= i and KeyList[n][2] == GetString(pathKey..KeyList[i][3]) then
                                            SetString(pathKey..KeyList[n][3], "")
                                            KeyList[n] = {KeyList[n][1], GetString(pathKey..KeyList[n][3]), KeyList[n][3]}
                                            sameKey = true
                                        end
                                    until (n == #KeyList or sameKey)
                                end
                                ReloadKeys()
                            end
                        UiPop()
                        UiTranslate(0, 45)
                    end
                end
                UiTranslate(0, 50)
                resetPressed = DrawButton("Reset Keys to Default", 500, 50, "regular.ttf", 40, 0.2, 1, 0.2)
                if resetPressed then
                    showResetKey = true
                    fadeKey = 0.7
                    for i=1, #setupKey do
                        SetString(pathKey..setupKey[i][1], setupKey[i][2])
                    end
                    ReloadKeys()
                end
                if showResetKey then
                    UiPush()
                        UiTranslate(0, 90)
                        SetValue("fadeKey", 0, "easein", 5)
                        UiColor(1, 1, 1, fadeKey)
                        UiFont("regular.ttf", 32)
                        UiText("Settings Has Been Reset")
                        if fadeKey == 0 then showResetKey = false end
                    UiPop()
                end
            UiPop()
        UiPop()
        --key bindis finish
    end

    UiPush()
    UiColor(1, 1, 1)
    UiButtonImageBox("MOD/options/box-outline-8.png", 6, 6, 1, 0.3, 0.3, 0.9)
    UiTranslate(bounds[1]/6, bounds[2]+200)
    UiAlign("center middle")

    UiColor(1, 1, 1)
    UiFont("bold.ttf", 40)
    close = UiTextButton("CLOSE", 500, 60)

    if close or InputPressed("esc") then visible = false end
    UiPop()

end

