
--Fix
function DoorClick(open, close, doors)
    if HasTag(GetPlayerPickBody(), "ALSdoor") then
        local door = GetPlayerPickBody()
        if InputPressed("grab") then
            if GetTagValue(door, "active") == open then
                SetTag(door, "active", close)
            elseif GetTagValue(door, "active") == close then
                SetTag(door, "active", open)
            end
        end
    end
    for i=1, #doors do
        local localdoors = GetBodyShapes(doors[i])
        if not HasTag(doors[i], "active") then
            SetTag(doors[i], "active", open)
        end
        for t=1, #localdoors do
            local doorJoints = GetShapeJoints(localdoors[t])
            if GetPlayerPickBody() == doors[i] or IsBodyActive(doors[i]) then
                if GetTagValue(doors[i], "active") == open then
                    for j=1, #doorJoints do
                        JointMortorSwith(doorJoints[j], 2, "min")
                    end
                elseif GetTagValue(doors[i], "active") == close then
                    RemoveTag(doors[i], "activedriver")
                    for j=1, #doorJoints do
                        JointMortorSwith(doorJoints[j], 2, "max")
                    end
                end
            end
        end
    end
end

--Fix
function DoorHold(doors)   
    if HasTag(GetPlayerPickBody(), "ALSdoor") then
        local door = GetPlayerPickBody()
        if InputPressed("grab") then
            if GetTagValue(door, "active") then
                SetTag(door, "forceopen")
                RemoveTag(door, "openonce")
            end
        end
    end

    if InputDown("Grab") then
        forceopen = true
    else
        forceopen = false
    end

    for i=1, #doors do
        local localdoors = GetBodyShapes(doors[i])
        for t=1, #localdoors do
            local doorJoints = GetShapeJoints(localdoors[t])
            if GetPlayerPickBody() == doors[i] or IsBodyActive(doors[i]) then
                if GetTagValue(doors[i], "active") and HasTag(doors[i], "forceopen") then
                    for j=1, #doorJoints do
                        JointMortorLock(doorJoints[j], 0, "max")
                    end
                    if not forceopen then
                        RemoveTag(doors[i], "forceopen")
                    end
                elseif GetTagValue(doors[i], "active") and not HasTag(doors[i], "forceopen") then
                    for j=1, #doorJoints do
                        JointMortorLock(doorJoints[j], 2, "min")
                    end
                end
            end
        end
    end
end

--FIx
function DoorExit(open, close, doors)
    for i=1, #doors do
        local localdoors = GetBodyShapes(doors[i]) 
        if not HasTag(doors[i], "active") then
            SetTag(doors[i], "active", open)
        end
        for t=1, #localdoors do
            local doorJoints = GetShapeJoints(localdoors[t])
            if GetPlayerVehicle() == GetBodyVehicle(doors[i]) and GetPlayerVehicle() ~= 0 then
                for j=1, #doorJoints do
                    JointMortorSwith(doorJoints[j], 2, "min")
                end
                if GetTagValue(doors[i], "ALSdoor") == "driver" then
                    SetTag(doors[i], "active", close)
                    SetTag(doors[i], "activedriver")
                    SetTag(doors[i], "openonce")
                else
                    SetTag(doors[i], "active", open)
                end
            elseif GetTagValue(doors[i], "active") == close and HasTag(doors[i], "openonce") then
                local min, max = GetJointLimits(doorJoints[1])
                if GetJointMovement(doorJoints[1]) <= max then
                    RemoveTag(doors[i], "activedriver")
                    for j=1, #doorJoints do
                        JointMortorSwith(doorJoints[j], 2, "max")
                    end
                end
            end
        end
    end
end

function JointMortorLock(joint, speed, direction)
    local min, max = GetJointLimits(joint)
    if GetJointType(joint) == "hinge" then
        if direction == "max" then
            SetJointMotor(joint, 0, 0)
        end
        if direction == "min" then
            if GetJointMovement(joint) < 5 then
                SetJointMotorTarget(joint, min, speed)
            end
        end
    elseif GetJointType(joint) == "prismatic" then
        if direction == "max" then
            SetJointMotor(joint, 0, 0)
        end
        if direction == "min" then
            if GetJointMovement(joint) < 5 then
            SetJointMotorTarget(joint, max, speed/math.pi)
            end
        end
    end
end

function JointMortorSwith(joint, speed, direction)
    local min, max = GetJointLimits(joint)
    if GetJointType(joint) == "hinge" then
        if direction == "max" then
            SetJointMotorTarget(joint, max, speed)
        else
            SetJointMotorTarget(joint, min, speed)
        end
    elseif GetJointType(joint) == "prismatic" then
        if direction == "max" then
            SetJointMotorTarget(joint, max, speed/math.pi)
        else
            SetJointMotorTarget(joint, min, speed/math.pi)
        end
    end
end

--==========--
--  sirens  --
--==========--

function ALS_ChangeSound(SoundShape, turnOn, tag, value)
    if turnOn then
        RemoveTag(SoundShape, tag)
    else
        SetTag(SoundShape, tag, value)
    end
end


function ALS_PlaySound(SoundShape, sirens1, sirens2, sirens3, sirens4, honks)
    if SoundShape ~= empty then
        for i=1, #SoundShape do
            ALSsiren = GetTagValue(SoundShape[i], "ALSsiren")
            local Shape = GetShapeWorldTransform(SoundShape[i])

            
            if HasTag(SoundShape[i], "Horn") then
                local honkNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 1, 2))
                PlayLoop(honks[honkNum], Shape.pos, GetFloat(pathUi .. "HornVolume")/500)
            else
                if not HasTag(SoundShape[i], "ALSsiren") then
                    if HasTag(SoundShape[i], "Yell") and not HasTag(SoundShape[i], "Yell2")  then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 3, 4))
                        PlayLoop(sirens1[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    elseif HasTag(SoundShape[i], "Yell") and HasTag(SoundShape[i], "Yell2")  then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 5, 6))
                        PlayLoop(sirens2[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                end

                if HasTag(SoundShape[i], "Yell") then
                    if ALSsiren == "1" then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 5, 6))
                        PlayLoop(sirens2[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                    if ALSsiren == "2" then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 7, 8))
                        PlayLoop(sirens3[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                    if ALSsiren == "3" then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 9, 10))
                        PlayLoop(sirens4[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                    if ALSsiren == "4" then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 1, 2))
                        PlayLoop(honks[sirenNum], Shape.pos, GetFloat(pathUi .. "HornVolume")/500)
                    end
                else
                    if ALSsiren == "1" then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 3, 4))
                        PlayLoop(sirens1[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                    if ALSsiren == "2" then   
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 5, 6))
                        PlayLoop(sirens2[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                    if ALSsiren == "3" then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 7, 8))
                        PlayLoop(sirens3[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                    if ALSsiren == "4" then
                        local sirenNum = tonumber(string.sub(GetTagValue(SoundShape[i], "ALShorn"), 9, 10))
                        PlayLoop(sirens4[sirenNum], Shape.pos, GetFloat(pathUi .. "SirenVolume")/500)
                    end
                end
            end
        end
    end
end

--=========--
--  Binds  --
--=========--

function ALS_CHangeEMS(vehicle, vehicletag, turnOn, tag, value)
    if HasTag(vehicle, vehicletag) then
        if turnOn then
            RemoveTag(vehicle, tag)
            RemoveTag(vehicle, "ALSsiren")
        else
            SetTag(vehicle, tag, value)
        end
    end
end


function ALS_Directional(vehicle, turnOn)
    if HasTag(vehicle, "directional") then
        if turnOn then
            RemoveTag(vehicle, "di")
        else
            SetTag(vehicle, "di")
        end
    end
end

function ALS_CHangeLights(vehicle, vehicletag, click, turnOn, tag)
    if HasTag(vehicle, vehicletag) then
        if turnOn then
            RemoveTag(vehicle, tag)
        else
            SetTag(vehicle, tag)
        end
    end
end

function ALS_CHangeMultipleLights(vehicle, click, turnOn, tag, value)
    if HasTag(vehicle, "ALS") then
        PlaySound(click[03],GetCameraTransform().pos,0.8)
        if turnOn then
            RemoveTag(vehicle, tag)
        else
            SetTag(vehicle, tag, value)
        end
    end
end


function drawVehicle(gUiScaleUpFactor, ctrlli, ctrl, uiKeys)
    
	local vehicle = GetPlayerVehicle()
    if HasTag(vehicle, "ALS") then
	local info = {}
        if InputPressed("f2") then
            help=not help
        end
        if help then
            info[#info+1] = {"f2", "----HIDE----"}
            info[#info+1] = {"",""}
        if HasTag(vehicle, "emergency") then
            info[#info+1] = {"--","Emergency Binds"}
            info[#info+1] = {uiKeys[1], "ALS Interface"}
            info[#info+1] = {ctrlli[9], "Emergency lights 1"}
            info[#info+1] = {ctrlli[10], "Emergency lights 2"}
            info[#info+1] = {ctrlli[11], "Emergency lights 3"}
            if HasTag(vehicle, "directional") then
                info[#info+1] = {ctrlli[12], "Directional lights"}
            end
            info[#info+1] = {ctrl[05], "Temporary Siren"}
            info[#info+1] = {ctrl[06], "Change Tone"}
            info[#info+1] = {ctrl[01], "Siren 1 (WAIL)"}
            info[#info+1] = {ctrl[02], "Siren 2 (YELP)"}
            info[#info+1] = {ctrl[03], "Siren 3 (PRTY)"}
            info[#info+1] = {ctrl[07], "Siren 4 (HI-LO)"}
            info[#info+1] = {"",""}
        end
        if HasTag(vehicle, "ALS") then
            info[#info+1] = {"--","Normal Binds"}
            info[#info+1] = {ctrlli[01], "Low-Beam"}
            info[#info+1] = {ctrlli[02], "High-Beam"}
            info[#info+1] = {ctrlli[03], "Flash High-Beam"}
            info[#info+1] = {ctrlli[04], "Fog Light"}
            if HasTag(vehicle, "aditional") then
                info[#info+1] = {ctrlli[06], "Aditional Light"}
            end
            info[#info+1] = {ctrlli[05], "Warning Lights"}
            info[#info+1] = {ctrlli[07].." "..ctrlli[08], "Blinkes Left/Right"}
            info[#info+1] = {ctrl[04], "Horn"}
        end
    else
        info[#info+1] = {"f2", "ALS BINDS"}
    end
        UiPush()
        UiAlign("top left")
        UiScale(gUiScaleUpFactor)

        local kw = 0
        local vw = 0
        for i=1, #info do
            UiFont("bold.ttf", 22)
            local w0 = 50
            if string.sub(info[i][1], 1, 4) ~= "RAW:" then
                w0 = UiGetTextSize(info[i][1])
            end
            UiFont("regular.ttf", 22)
            local w1 = UiGetTextSize(info[i][2])
            kw = math.max(kw,w0)
            vw = math.max(vw,w1)
        end

        local w = kw + vw + 50
        local h = #info*22 + 30
        UiTranslate(UiWidth()/gUiScaleUpFactor-w-20, UiHeight()/gUiScaleUpFactor-h-200)
        UiColor(0,0,0,0.5)
        UiImageBox("MOD/images/box-solid-6.png", w, h, 6, 6)
        UiTranslate(kw + 20, 32)
        UiColor(1,1,1)
        for i=1, #info do
            local key = info[i][1]
            local func = info[i][2]
            UiFont("bold.ttf", 22)
            UiAlign("right")
            if string.sub(key, 1, 4) == "RAW:" then
                local paths = {}
                while true do
                    local idx = string.find(key, "RAW:", 5)
                    local path = key
                    if idx ~= nil then
                        path = string.sub(key, 1, idx - 1)
                        key = string.sub(key, idx)
                    end
                    paths[#paths+1] = trim(path)
                    if idx == nil then
                        break
                    end
                end
                UiPush()
                    UiTranslate(0, -16)
                    for k=#paths,1,-1 do
                        UiImageBox(paths[k], 20, 20, 0, 0)
                        UiTranslate(-28, 0)
                    end
                UiPop()
            else
                UiText(key)
            end
            UiTranslate(10, 0)
            UiFont("regular.ttf", 22)
            UiAlign("left")
            if string.sub(func, 1, 4) == "RAW:" then
                UiTranslate(0, -18)
                UiImageBox(func, 20, 20, 0, 0)
                UiTranslate(0, 18)
            else
                UiText(func)
            end
            UiTranslate(-10, 22)
        end
        UiPop()
    end
end


function DrawButton(text, w, h, font, size, R, G, B)
    UiPush()
        UiButtonPressDist(2)
        UiFont(font, size)
        UiButtonImageBox("options/box-1.png", 6, 6)
        if UiTextButton(text, w, h) then
            press = true
        else
            press = false
        end
    UiPop()
    return press
end


function DrawChangeButton(condition, text1, w, h, font, size, R, G, B)
    local press = false
    UiPush()
        UiButtonPressDist(3)
        UiFont(font, size)
        if condition then
            UiButtonImageBox("options/box-outline-8.png", 6, 6, 1.5,1.2,1.2)
            UiColor(R-0.8, G-0.8, B-0.8)
            UiButtonHoverColor(R*1.2, G*0.5, B*0.5)
            local dt = GetTimeStep()
            
            frame = frame + dt*60
            local period = 75
            local t = math.ceil(frame) % period
            if frame > 75 then
                frame = 0
            end
            if t <= 25 then
                UiFont(font, 40)
                text3 = "."
            elseif t>=25 and t<=50 then
                UiFont(font, 40)
                text3 = ".."
            elseif t>=50 then
                UiFont(font, 40)
                text3 = "..."
            end
            if UiTextButton(text3, w, h) then
                condition = not condition
                press = true
            end
        else
            UiButtonImageBox("options/box-outline-8.png", 6, 6, 1,1,1)
            UiColor(1, 1, 1)
            if text1 == "None" then
                UiButtonHoverColor(R*1.2, G*0.5, B*0.5)
            else
                UiButtonHoverColor(R*0.6, G, B*0.6)
            end

            if UiTextButton(text1, w, h) then
                condition = not condition
                press = true
            end
        end
    UiPop()
    return press, condition
end


function DrawSlider(value, length, R, G, B, dotR, dotG, dotB)
    UiPush()
        UiAlign("left middle")
        UiColor(R, G, B)
        UiRect(length+20, 20)
        UiColor(dotR, dotG, dotB)
        slidValue, done = UiSlider("ui/common/box-solid-4.png", x, value, 0, length)
    UiPop()
    return slidValue, done
end



--temporary
--fix this
function lightsPatter()

    if patter[1] ==0 then 
        FTE1 = 0        FTD1 = 0
        FTE2 = 0        FTD2 = 0
        elseif patter[1] ==1 then
        FTE1 = a1        FTD1 = a2
        FTE2 = a1        FTD2 = a2
        elseif patter[1]==2 then
        FTE1 = a1        FTD1 = a2
        FTE2 = a2        FTD2 = a1
        elseif patter[1]==3 then
        FTE1 = a3        FTD1 = a4
        FTE2 = a2        FTD2 = a1
        elseif patter[1]==4 then
        FTE1 = a1        FTD1 = a2
        FTE2 = a3        FTD2 = a4
        elseif patter[1]==5 then
        FTE1 = a3        FTD1 = a4
        FTE2 = a4        FTD2 = a3
        end

        if patter[2]==0 then
        CMD1 = 0        CME1 = 0
        CMD2 = 0        CME2 = 0
        CMD3 = 0        CME3 = 0
        CMD4 = 0        CME4 = 0
        CMD5 = 0        CME5 = 0
        elseif patter[2]==1 then
        CMD1 = a1       CME1 = a2
        CMD2 = 0        CME2 = 0
        CMD3 = 0        CME3 = 0
        CMD4 = 0        CME4 = 0
        CMD5 = a1       CME5 = a2
        elseif patter[2]==2 then
        CMD1 = a1       CME1 = a2
        CMD2 = a1       CME2 = a2
        CMD3 = a1       CME3 = a2
        CMD4 = a1       CME4 = a2
        CMD5 = a1       CME5 = a2
        elseif patter[2]==3 then
        CMD1 = a3       CME1 = a4
        CMD2 = a3       CME2 = a4
        CMD3 = a3       CME3 = a4
        CMD4 = a3       CME4 = a4
        CMD5 = a3       CME5 = a4
        elseif patter[2]==4 then
        CMD1 = a3       CME1 = a4
        CMD2 = a4       CME2 = a3
        CMD3 = a3       CME3 = a4
        CMD4 = a4       CME4 = a3
        CMD5 = a3       CME5 = a4
        elseif patter[2]==5 then 
        CMD1 = a3       CME1 = a4
        CMD2 = a1       CME2 = a2
        CMD3 = a6       CME3 = a5
        CMD4 = a4       CME4 = a3
        CMD5 = a5       CME5 = a6  
        end

        if patter[3]==0 then
        C2D1 = 0        C2E1 = 0
        C2D2 = 0        C2E2 = 0
        C2D3 = 0        C2E3 = 0
        elseif patter[3]==1 then
        C2D1 = a2       C2E1 = a1
        C2D2 = a2       C2E2 = a1
        C2D3 = a2       C2E3 = a1
        elseif patter[3]==2 then
        C2D1 = a3        C2E1 = a4
        C2D2 = a3        C2E2 = a4
        C2D3 = a3        C2E3 = a4
        elseif patter[3]==3 then
        C2D1 = a5        C2E1 = a6
        C2D2 = a5        C2E2 = a6
        C2D3 = a5        C2E3 = a6
        elseif patter[3]==4 then
        C2D1 = a4        C2E1 = a3
        C2D2 = a3        C2E2 = a4
        C2D3 = a4        C2E3 = a3
        elseif patter[3]==5 then
        C2D1 = a1        C2E1 = a1
        C2D2 = a3        C2E2 = a3
        C2D3 = a1        C2E3 = a1
        end

        if patter[4]==0 then
        LDD1 = 0        LDE1 = 0
        LDD2 = 0        LDE2 = 0
        LDD3 = 0        LDE3 = 0
        LDD4 = 0        LDE4 = 0
        elseif patter[4]==1 then
        LDD1 = a2       LDE1 = a1
        LDD2 = a1       LDE2 = a2
        LDD3 = a1       LDE3 = a2
        LDD4 = a2       LDE4 = a1
        elseif patter[4]==2 then
        LDD1 = a3       LDE1 = a4
        LDD2 = a4       LDE2 = a3
        LDD3 = a4       LDE3 = a3
        LDD4 = a3       LDE4 = a4
        elseif patter[4]==3 then
        LDD1 = a1       LDE1 = a1
        LDD2 = a2       LDE2 = a2
        LDD3 = a2       LDE3 = a2
        LDD4 = a1       LDE4 = a1
        elseif patter[4]==4 then
        LDD1 = a3       LDE1 = a4
        LDD2 = a5       LDE2 = a6
        LDD3 = a6       LDE3 = a5
        LDD4 = a4       LDE4 = a3
        elseif patter[4]==5 then
        LDD1 = a6       LDE1 = a5
        LDD2 = a5       LDE2 = a6
        LDD3 = a5       LDE3 = a6
        LDD4 = a6       LDE4 = a5
        end

        if patter[5]==0 then
        TZD1 = 0        TZE1 = 0
        TZD2 = 0        TZE2 = 0
        elseif patter[5]==1 then
        TZD1 = a1       TZE1 = a2
        TZD2 = a1       TZE2 = a2
        elseif patter[5]==2 then
        TZD1 = a2       TZE1 = a1
        TZD2 = a1       TZE2 = a2
        elseif patter[5]==3 then
        TZD1 = a1       TZE1 = a2
        TZD2 = a2       TZE2 = a1
        elseif patter[5]==4 then
        TZD1 = a3       TZE1 = a4
        TZD2 = a3       TZE2 = a4
        elseif patter[5]==5 then
        TZD1 = a3       TZE1 = a4
        TZD2 = a4       TZE2 = a3
        end

        if patter[6]==0 then
        FFD1 = 0        FFE1 = 0
        elseif patter[6]==1 then
        FFD1 = a1       FFE1 = a2
        elseif patter[6]==2 then
        FFD1 = a3       FFE1 = a4
        elseif patter[6]==3 then
        FFD1 = a5       FFE1 = a6
        elseif patter[6]==4 then
        FFD1 = a2       FFE1 = a1
        elseif patter[6]==5 then
        FFD1 = a4       FFE1 = a3
        end

        if patter[7]==0 then
        LTD1 = 0        LTE1 = 0
        elseif patter[7]==1 then
        LTD1 = a1       LTE1 = a2
        elseif patter[7]==2 then
        LTD1 = a3       LTE1 = a4
        elseif patter[7]==3 then
        LTD1 = a5       LTE1 = a6
        elseif patter[7]==4 then
        LTD1 = a2       LTE1 = a1
        elseif patter[7]==5 then
        LTD1 = a4       LTE1 = a3
        end

        if patter[8]==0 then
        LFD1 = 0        LFE1 = 0
        elseif patter[8]==1 then
        LFD1 = a1        LFE1 = a2
        elseif patter[8]==2 then
        LFD1 = a3        LFE1 = a4
        elseif patter[8]==3 then
        LFD1 = a5        LFE1 = a6
        elseif patter[8]==4 then
        LFD1 = a2        LFE1 = a1
        elseif patter[8]==5 then
        LFD1 = a4        LFE1 = a3
        end

        if patter[9]==0 then
        BLD1 = 0        BLE1 = 0
        elseif patter[9]==1 then
        BLD1 = a1       BLE1 = a2
        elseif patter[9]==2 then
        BLD1 = a2       BLE1 = a1
        elseif patter[9]==3 then
        BLD1 = a1       BLE1 = a2
        elseif patter[9]==4 then
        BLD1 = a3       BLE1 = a4
        elseif patter[9]==5 then
        BLD1 = a3       BLE1 = a4
        end
        local veh=GetPlayerVehicle()
        if GetTagValue(veh, "directional")=="0" then
        DLD1 = 0        DLE1 = 0
        DLD2 = 0        DLE2 = 0
        DLD3 = 0        DLE3 = 0
        DLD4 = 0        DLE4 = 0
        DLD5 = 0        DLE5 = 0
        elseif GetTagValue(veh, "directional")=="1" then
        DLD1 = b1       DLE1 = b10
        DLD2 = b2       DLE2 = b9
        DLD3 = b3       DLE3 = b8
        DLD4 = b4       DLE4 = b7
        DLD5 = b5       DLE5 = b6
        elseif GetTagValue(veh, "directional")=="2" then
        DLD1 = b10      DLE1 = b1
        DLD2 = b9       DLE2 = b2
        DLD3 = b8       DLE3 = b3
        DLD4 = b7       DLE4 = b4
        DLD5 = b6       DLE5 = b5
        elseif GetTagValue(veh, "directional")=="3" then
        DLD1 = a1       DLE1 = a2
        DLD2 = a1       DLE2 = a2
        DLD3 = a1       DLE3 = a2
        DLD4 = a1       DLE4 = a2
        DLD5 = a1       DLE5 = a2
        elseif GetTagValue(veh, "directional")=="4" then
        DLD1 = a1       DLE1 = a1
        DLD2 = a1       DLE2 = a1
        DLD3 = a1       DLE3 = a1
        DLD4 = a2       DLE4 = a2
        DLD5 = a2       DLE5 = a2
        elseif GetTagValue(veh, "directional")=="5" then
        DLD1 = a4       DLE1 = a4
        DLD2 = a6       DLE2 = a6
        DLD3 = a1       DLE3 = a1
        DLD4 = a2       DLE4 = a2
        DLD5 = a3       DLE5 = a3
        end

end







--fix this /create permutation/
function patterimage(t)

    if t == 0 then
        a1 = 1 a2= 0
        a3 = 1 a4 = 0
        a5 = 1 a6 = 0
        b1 = 1
        lightsPatter()
    end
    if t == 5 then
        b2 = 1
        a3 = 0
        lightsPatter()
    end
    if t == 10 then
        a5 = 0 a6 = 1
        b1 = 0
        b3 = 1
        a3 = 1
        lightsPatter()
    end
    if t == 15 then
        a1 = 0 a2= 1
        a3 = 0
        b2 = 0
        b4 = 1
        lightsPatter()
    end
    if t == 20 then
        a5 = 1 a6 = 0
        b3 = 0
        b5 = 1
        a3 = 1
        lightsPatter()
    end
    if t == 25 then
        b4 = 0
        b6 = 1
        lightsPatter()
    end
    if t == 30 then
        a1 = 1 a2= 0
        a3 = 0 a4= 1
        a5 = 0 a6 = 1
        b5 = 0
        b7 = 1
        lightsPatter()
    end
    if t == 35 then
        a4= 0
        b6 = 0
        b8 = 1
        lightsPatter()
    end
    if t == 40 then
        a5 = 1 a6 = 0
        a4= 1
        b7 = 0
        b9 = 1
        lightsPatter()
    end
    if t == 45 then
        a4= 0
        a1 = 0 a2= 1
        b8 = 0
        b10 = 1
        lightsPatter()
    end
    if t == 50 then
        a5 = 0 a6 = 1
        a4= 1
        b9 = 0
        lightsPatter()
    end
    if t == 55 then
        b10 = 0
        lightsPatter()
    end
    if t == 60 then
        a1= 1 a2= 0
        a3= 1 a4= 0
        a5 = 1 a6 = 0
        lightsPatter()
    end
    if t == 65 then
        a3= 0
        lightsPatter()
    end
    if t == 70 then
        a5 = 0 a6 = 1
        a3= 1
        lightsPatter()
    end
    if t == 75 then
        a1 = 0 a2= 1
        a3= 0
        lightsPatter()
    end
    if t == 80 then
        a5 = 1 a6 = 0
        a3= 1
        lightsPatter()
    end
    if t == 85 then
        lightsPatter()
    end
    if t == 90 then
        a1 = 1 a2= 0
        a3= 0  a4= 1
        a5 = 0 a6 = 1
        lightsPatter()
    end
    if t == 95 then
        a4= 0
        lightsPatter()
    end
    if t == 100 then
        a5 = 1 a6 = 0
        a4= 1
        lightsPatter()
    end
    if t == 105 then
        a4= 0
        a1 = 0 a2= 1
        lightsPatter()
    end
    if t == 110 then
        a5 = 0 a6 = 1
        a4= 1
        lightsPatter()
    end
    if t == 115 then
        lightsPatter()
    end
    if t == 119 then
        lightsPatter()
    end
end









--make it better
function drawOptionsF3()


    --fix to get only one time
    local veh = GetPlayerVehicle()

    if GetTagValue(veh, "em") == "1" then
        patter = {
            tonumber(string.sub(GetTagValue(veh, "pry"), 1,2)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 3,4)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 5,6)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 7,8)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 9,10)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 11,12)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 13,14)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 15,16)),
            tonumber(string.sub(GetTagValue(veh, "pry"), 17,18)),
        }  
    elseif GetTagValue(veh, "em") == "2" then
        patter = {
            tonumber(string.sub(GetTagValue(veh, "sec"), 1,2)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 3,4)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 5,6)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 7,8)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 9,10)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 11,12)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 13,14)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 15,16)),
            tonumber(string.sub(GetTagValue(veh, "sec"), 17,18)),
        }  
    elseif GetTagValue(veh, "em") == "3" then
        patter = {
            tonumber(string.sub(GetTagValue(veh, "ter"), 1,2)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 3,4)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 5,6)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 7,8)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 9,10)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 11,12)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 13,14)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 15,16)),
            tonumber(string.sub(GetTagValue(veh, "ter"), 17,18)),
        } 
    else
        patter = {0,0,0,0,0,0,0,0,0} 
    end


    if HasTag(veh, "di") then
        patterDirec = tonumber(GetTagValue(veh, "directional"))
    else
        patterDirec = 0
    end





    if InputPressed("rmb") then
        movecamera=not movecamera
    end
    if not movecamera then
    UiMakeInteractive()
    end

    local w = UiWidth()
    local h = UiHeight()
    UiTranslate(w,h/2.3)
    UiScale(0.7,0.7)



    UiPush()
    UiAlign("right middle")
    UiImage("MOD/images/Interface.png")
    UiPush()   
    UiTranslate(-180, -420)
    UiColor(1, 1, 1)
    UiFont("regular.ttf", 40)
    if not movecamera then
    UiText("Right click to move the camera")
    else
    UiText("Right click to go back to edit")
    end
    UiPop()

    UiPush()
    UiColor(1, 1, 1)
    UiButtonImageBox("MOD/images/box-buttons.png", 6, 6, 1, 0.3, 0.3, 0.9)
    UiTranslate(-70, 430)

    UiColor(1, 1, 1)
    UiFont("bold.ttf", 40)
    close = UiTextButton("CLOSE", 600, 60)

    if close or InputPressed("esc") then showpanel = false end
    UiPop()
    --FFN
        UiPush()
            UiPush()
                if patter[6] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
            end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[6], "FFN")
            if somar then
                atualizar=true
            patter[6] = patter[6]-1
                if patter[6] < 0 then
                    patter[6]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
            patter[6] = patter[6]+1
                if patter[6] > 5 then
                    patter[6]=0
                end
            end
        UiPop()
    --CME
        UiPush()
            UiTranslate(0,160)
            UiPush()
                if patter[2] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[2], "CME")
            if somar then
                atualizar=true
                patter[2] = patter[2]-1
                if patter[2] < 0 then
                    patter[2]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
                patter[2] = patter[2]+1
                if patter[2] > 5 then
                    patter[2]=0
                end
            end
        UiPop()
    --LTN
        UiPush()
            UiTranslate(0,320)
            UiPush()
                if patter[7] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[7], "LTN")
            if somar then
                atualizar=true
            patter[7] = patter[7]-1
                if patter[7] < 0 then
                    patter[7]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
            patter[7] = patter[7]+1
                if patter[7] > 5 then
                    patter[7]=0
                end
            end
        UiPop()

    --SIRENE
        UiPush()
        local findvehicle = GetPlayerVehicle()
            UiTranslate(0,480)
            UiPush()
                if HasTag(findvehicle, "ALSsiren") or HasTag(findvehicle, "Yell") then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiColor(0,0,0)
            UiTranslate(-694,-205)
            UiFont("regular.ttf", 30)
            UiText("SIREN")
            UiColor(1,1,1)
            UiTranslate(5,50)
            if not HasTag(findvehicle, "Yell") then
                if GetTagValue(findvehicle, "ALSsiren") == "1" then
                UiTranslate(-10,0)
                UiText("WAIL")
                elseif GetTagValue(findvehicle, "ALSsiren") == "2" then
                UiTranslate(-15,0)
                UiText("YELP")
                elseif GetTagValue(findvehicle, "ALSsiren") == "3" then
                UiTranslate(-12,0)
                UiText("PRTY")
                elseif GetTagValue(findvehicle, "ALSsiren") == "4" then
                UiTranslate(-15,0)
                UiText("HILO")
                else
                UiTranslate(-25,0)
                UiText("----")    
                end   
            end
            if HasTag(findvehicle, "Yell") then
                if GetTagValue(findvehicle, "ALSsiren") == "1" then
                UiTranslate(-10,0)
                UiText("YELP")
                elseif GetTagValue(findvehicle, "ALSsiren") == "2" then
                UiTranslate(-15,0)
                UiText("PRTY")
                elseif GetTagValue(findvehicle, "ALSsiren") == "3" then
                UiTranslate(-12,0)
                UiText("HILO")
                elseif GetTagValue(findvehicle, "ALSsiren") == "4" then
                UiTranslate(-6,0)
                UiText("HORN")
                else
                    UiTranslate(-5,0)
                    UiText("TEMP")
                end 
            end

        UiPop()

        UiTranslate(109,0)
    --FTE
        UiPush()
            UiPush()
                if patter[1] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
            end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[1], "FTE")
            if somar then
                atualizar=true
            patter[1] = patter[1]-1
                if patter[1] < 0 then
                    patter[1]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
            patter[1] = patter[1]+1
                if patter[1] > 5 then
                    patter[1]=0
                end
            end
        UiPop()

    --CM2
        UiPush()
            UiTranslate(0,160)
            UiPush()
                if patter[3] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[3], "CM2")
            if somar then
                atualizar=true
            patter[3] = patter[3]-1
                if patter[3] < 0 then
                    patter[3]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
            patter[3] = patter[3]+1
                if patter[3] > 5 then
                    patter[3]=0
                end
            end
        UiPop()

    --LFN
        UiPush()
            UiTranslate(0,320)
            UiPush()
                if patter[8] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[8], "LFN")
            if somar then
                atualizar=true
            patter[8] = patter[8]-1
                if patter[8] < 0 then
                    patter[8]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
            patter[8] = patter[8]+1
                if patter[8] > 5 then
                    patter[8]=0
                end
            end
        UiPop()


    --LUZEXTRA/BUZINA
        UiPush()
            UiTranslate(-686.5,275)
            UiPush()
                if ad then
                    UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
                UiColor(0,0,0)
                UiTranslate(-7.5,0)
                UiFont("regular.ttf", 30)
                UiText("LAMP")
            UiPop()
            UiTranslate(0,51)            
            UiPush()
            if HasTag(findvehicle, "Horn") then
                UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
            end
            UiColor(0,0,0)
            UiTranslate(-7.5,0)
            UiFont("regular.ttf", 30)
            UiText("HORN")
            UiPop()


        UiPop()

        UiTranslate(111,0)

    --LDE
        UiPush()
            UiPush()
                if patter[4] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[4], "LDE")
            if somar then
                atualizar=true
            patter[4] = patter[4]-1
                if patter[4] < 0 then
                    patter[4]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
            patter[4] = patter[4]+1
                if patter[4] > 5 then
                    patter[4]=0
                end
            end
        UiPop()

    --TZE
        UiPush()
            UiTranslate(0,160)
            UiPush()
                if patter[5] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[5], "TZE")
            if somar then
                atualizar=true
            patter[5] = patter[5]-1
                if patter[5] < 0 then
                    patter[5]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
            patter[5] = patter[5]+1
                if patter[5] > 5 then
                    patter[5]=0
                end
            end
        UiPop()

        --BLN
            UiPush()
            UiTranslate(0,320)
            UiPush()
                if patter[9] > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patter[9], "BLN")
            if somar then
                atualizar=true
                patter[9] = patter[9]-1
                if patter[9] < 0 then
                    patter[9]=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizar=true
                patter[9] = patter[9]+1
                if patter[9] > 5 then
                    patter[9]=0
                end
            end
        UiPop()

    --DIRECIONAL
        UiPush()
            UiTranslate(0,480)
            UiPush()
            if HasTag(veh, "di") then
                if patterDirec > 0 then
            UiTranslate(-686.5,-205)
            UiImageBox("MOD/images/box-lights.png", 90, 40, 10, 10)
                end
            end
            UiPop()
            UiTranslate(-737,-251)
            somar = DrawButtonsF3(somar, "<", 40, 30, 2, 40, 0, 0, 0, patterDirec, "<<>>")
            if somar then
                atualizardi=true
            patterDirec = patterDirec-1
                if patterDirec < 0 then
                    patterDirec=5
                end
            end
            UiTranslate(50,0)
            subtrair = DrawButtonsF3(subtrair, ">", 40, 30, 2, 40, 0, 0, 0)
            if subtrair then
                atualizardi=true
            patterDirec = patterDirec+1
                if patterDirec > 5 then
                    patterDirec=0
                end
            end
        UiPop()
    --end    
        if HasTag(veh, "em") then
            --PADROES
            UiPush()
            UiTranslate(-476,-227)
            UiPush()
            --fente farol
            if FFE1 == 1 then
                UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(143,0)        
            if FFD1 == 1 then
                UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(-160,40)
            --frente
            UiPush()
            if  FTE1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  FTE2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(109,0)
            if  FTD2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  FTD1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()

            UiTranslate(-66,41)
            --lado
            UiPush()
            if  LDE1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  LDE2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  LDE3== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  LDE4== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end

            UiTranslate(107,0)
            if  LDD4== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  LDD3== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  LDD2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  LDD1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()

            UiTranslate(0,70)
            --cima
            UiPush()
            if  CME1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  CME2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  CME3== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  CME4== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  CME5== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end

            UiTranslate(40,0)
            if  CMD5== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(33,0)
            if  CMD4== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  CMD3== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  CMD2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  CMD1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()

            UiTranslate(67,67)
            --cima2
            UiPush()
            if  C2E1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  C2E2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  C2E3== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end

            UiTranslate(41,0)
            if  C2D3== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(33,0)
            if  C2D2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  C2D1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()

            UiTranslate(0,47)
            --traz
            UiPush()
            if  TZE1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(34,0)
            if  TZE2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end

            UiTranslate(108,0)
            if  TZD2== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(33,0)
            if  TZD1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()

            UiTranslate(17,44)

            --trazfarol
            UiPush()
            if  LTE1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end

            UiTranslate(142,0)
            if  LTD1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()
            UiTranslate(0,35)
            --trazfpry[9]o
            UiPush()
            if  LFE1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(142,0)
            if  LFD1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()

            UiTranslate(0,35)
            --re
            UiPush()
            if  BLE1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiTranslate(142,0)
            if  BLD1== 1 then
            UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
            end
            UiPop()

            UiPop()
            UiPop()
        end
    if HasTag(veh, "di") then
        UiPush()
        UiTranslate(-595,296)
        --direcional
        UiPush()
        if DLE1==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLE2==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLE3==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLE4==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLE5==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(46,0)
        if DLD5==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLD4==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLD3==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLD2==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiTranslate(35,0)
        if DLD1==1 then
        UiImageBox("MOD/images/box-lights.png", 27, 27, 10, 10)
        end
        UiPop()
        UiPop()
    end
    UiPop()

    if atualizar then
        if GetTagValue(veh, "em") == "1" then
            SetTag(veh, "pry", string.format("%02d", patter[1])..string.format("%02d", patter[2])..string.format("%02d", patter[3])..string.format("%02d", patter[4])..string.format("%02d", patter[5])..string.format("%02d", patter[6])..string.format("%02d", patter[7])..string.format("%02d", patter[8])..string.format("%02d", patter[9]))
            SetTag(veh, "update")
            if TDMP_LocalSteamId then
                local p = "pry" local d = GetTagValue(veh, "pry")
                TDMP_ClientStartEvent("ALS_SendPatter", { Reliable = true, Data = {p, d} })
            end
        elseif GetTagValue(veh, "em") == "2" then
            SetTag(veh, "sec", string.format("%02d", patter[1])..string.format("%02d", patter[2])..string.format("%02d", patter[3])..string.format("%02d", patter[4])..string.format("%02d", patter[5])..string.format("%02d", patter[6])..string.format("%02d", patter[7])..string.format("%02d", patter[8])..string.format("%02d", patter[9]))
            SetTag(veh, "update")
            if TDMP_LocalSteamId then
                local p = "sec" local d = GetTagValue(veh, "sec")
                TDMP_ClientStartEvent("ALS_SendPatter", { Reliable = true, Data = {p, d} })
            end
        elseif GetTagValue(veh, "em") == "3" then
            SetTag(veh, "ter", string.format("%02d", patter[1])..string.format("%02d", patter[2])..string.format("%02d", patter[3])..string.format("%02d", patter[4])..string.format("%02d", patter[5])..string.format("%02d", patter[6])..string.format("%02d", patter[7])..string.format("%02d", patter[8])..string.format("%02d", patter[9]))
            SetTag(veh, "update")
            if TDMP_LocalSteamId then
                local p = "ter" local d = GetTagValue(veh, "ter")
                TDMP_ClientStartEvent("ALS_SendPatter", { Reliable = true, Data = {p, d} })
            end
        end
        atualizar=false
    end

    if atualizardi then
        if HasTag(veh, "di") then
            SetTag(veh, "directional",  patterDirec)
            if TDMP_LocalSteamId then
                local p = patterDirec
                TDMP_ClientStartEvent("ALS_SendPatterDirectional", { Reliable = true, Data = {p} })
            end
        end
        atualizardi=false
    end
    
end

function DrawButtonsF3(condicao, texto, w, h, fonte, tamanho, R, G, B, numero, nome)
    UiPush()
        UiButtonHoverColor(1, 0.8, 0.7)
        UiButtonPressColor(1, 0.6, 0.4)
        UiButtonPressDist(0)
        UiFont("regular.ttf", tamanho*1.2)
        UiButtonImageBox("MOD/images/box-buttons.png", 6, 6)
        UiColor(R,G,B)
        if UiTextButton(texto, w, h) then
            PlaySound(click)
            condicao = true
        else
            condicao = false        
        end
        UiTranslate(40,45)     
        UiFont("regular.ttf", tamanho)
        UiText(nome)
        UiColor(1,1,1)
        UiTranslate(10,50)
        if numero==0 then
        UiText("OFF")
        else
        UiText(numero)
        end
    UiPop()
    return condicao
end