updateVersion = "0.1"

pathUpdate = "savegame.mod.Update."
pathKey = "savegame.mod.key."
pathUi = "savegame.mod.ui."


setupKey = {}
setupKey[#setupKey+1] = {"menu", "f3"}
setupKey[#setupKey+1] = {"lightMode", "J"}
setupKey[#setupKey+1] = {"headLight", "K"}
setupKey[#setupKey+1] = {"lightSignal", "L"}
setupKey[#setupKey+1] = {"foglight", "H"}
setupKey[#setupKey+1] = {"primary", "I"}
setupKey[#setupKey+1] = {"secondary", "O"}
setupKey[#setupKey+1] = {"tertiary", "P"}
setupKey[#setupKey+1] = {"warning", "M"}
setupKey[#setupKey+1] = {"additional", "N"}
setupKey[#setupKey+1] = {"blinkerR", "."}
setupKey[#setupKey+1] = {"blinkerL", ","}
setupKey[#setupKey+1] = {"siren1", "1"}
setupKey[#setupKey+1] = {"siren2", "2"}
setupKey[#setupKey+1] = {"siren3", "3"}
setupKey[#setupKey+1] = {"siren4", "4"}
setupKey[#setupKey+1] = {"sirenhold1", "V"}
setupKey[#setupKey+1] = {"sirenhold2", "B"}
setupKey[#setupKey+1] = {"horn", "G"}
setupKey[#setupKey+1] = {"directional", "U"}

setupUiDoor = {}
setupUiDoor[#setupUiDoor+1] = {"HoldDoor", "bool", true}
setupUiDoor[#setupUiDoor+1] = {"ClickDoor", "bool", false}
setupUiDoor[#setupUiDoor+1] = {"OpenWhenExit", "bool", false}
setupUiDoor[#setupUiDoor+1] = {"Deactivatedoors", "bool", false}
setupUiDoor[#setupUiDoor+1] = {"FPS", "bool", false}

setupUiLights = {}
setupUiLights[#setupUiLights+1] = {"Lightsf", "float", 150}
setupUiLights[#setupUiLights+1] = {"Lightst", "float", 25}
setupUiLights[#setupUiLights+1] = {"HighBeam", "float", 150}
setupUiLights[#setupUiLights+1] = {"EmLights", "float", 50}
setupUiLights[#setupUiLights+1] = {"HornVolume", "float", 250}
setupUiLights[#setupUiLights+1] = {"SirenVolume", "float", 250}


---- Key Binding ----
KeyList = {}
KeyList[#KeyList+1] = {"Basic Control", "Basic Control"}
KeyList[#KeyList+1] = {"Light Mode Selection", GetString(pathKey.."lightMode"), "lightMode"}
KeyList[#KeyList+1] = {"Headlight Control", GetString(pathKey.."headLight"), "headLight"}
KeyList[#KeyList+1] = {"Flash Light (Light Signal)", GetString(pathKey.."lightSignal"), "lightSignal"}
KeyList[#KeyList+1] = {"Fog Light", GetString(pathKey.."foglight"), "foglight"}
KeyList[#KeyList+1] = {"Warning Lights", GetString(pathKey.."warning"), "warning"}
KeyList[#KeyList+1] = {"Blinker Right", GetString(pathKey.."blinkerR"), "blinkerR"}
KeyList[#KeyList+1] = {"Blinker Left", GetString(pathKey.."blinkerL"), "blinkerL"}
KeyList[#KeyList+1] = {"Additional light", GetString(pathKey.."additional"), "additional"}
KeyList[#KeyList+1] = {"Sounds", "Sounds"}
KeyList[#KeyList+1] = {"Siren/Sound primary", GetString(pathKey.."siren1"), "siren1"}
KeyList[#KeyList+1] = {"Siren/Sound secondary", GetString(pathKey.."siren2"), "siren2"}
KeyList[#KeyList+1] = {"Siren/Sound tertiary", GetString(pathKey.."siren3"), "siren3"}
KeyList[#KeyList+1] = {"Siren/Sound fourth", GetString(pathKey.."siren4"), "siren4"}
KeyList[#KeyList+1] = {"Siren/Sound Play/Change Tone", GetString(pathKey.."sirenhold1"), "sirenhold1"}
KeyList[#KeyList+1] = {"siren/Sound Change Tone", GetString(pathKey.."sirenhold2"), "sirenhold2"}
KeyList[#KeyList+1] = {"Horn", GetString(pathKey.."horn"), "horn"}
KeyList[#KeyList+1] = {"Emergency Lights", "Emergency Lights"}
KeyList[#KeyList+1] = {"Emergency Light Interface", GetString(pathKey.."menu"), "menu"}
KeyList[#KeyList+1] = {"Emergency Lights primary", GetString(pathKey.."primary"), "primary"}
KeyList[#KeyList+1] = {"Emergency Lights secondary", GetString(pathKey.."secondary"), "secondary"}
KeyList[#KeyList+1] = {"Emergency Lights tertiary", GetString(pathKey.."tertiary"), "tertiary"}
KeyList[#KeyList+1] = {"Directional Lights", GetString(pathKey.."directional"), "directional"}



function Setup()
    
    if not GetBool(pathUpdate.."firtopen") then
        
        for i=1, #setupKey do
            SetString(pathKey..setupKey[i][1], setupKey[i][2])
        end
    
        for i=1, #setupUiDoor do
            if setupUiDoor[i][2] == "bool" then
                SetBool(pathUi..setupUiDoor[i][1], setupUiDoor[i][3])
            end
        end

        for i=1, #setupUiLights do
            if setupUiLights[i][2] == "float" then
                SetFloat(pathUi..setupUiLights[i][1], setupUiLights[i][3])
            end
        end

        if not GetBool(pathUpdate.."firtopen") then
            SetBool(pathUpdate.."firtopen", true)
        end

    elseif GetString("savegame.mod.version") ~= updateVersion then
        SetBool(pathUpdate.."update", true)
        for i=1, #setupKey do
            if not HasKey(pathKey..setupKey[i][1]) then
                SetString(pathKey..setupKey[i][1], setupKey[i][2])
            end
        end

        for i=1, #setupKey do
            SetString(pathKey..setupKey[i][1], setupKey[i][2])
        end
    
        for i=1, #setupUiDoor do
            if setupUiDoor[i][2] == "bool" then
                SetBool(pathUi..setupUiDoor[i][1], setupUiDoor[i][3])
            end
        end

        for i=1, #setupUiLights do
            if setupUiLights[i][2] == "float" then
                SetFloat(pathUi..setupUiLights[i][1], setupUiLights[i][3])
            end
        end
    
        ReloadKeys()
            SetString("savegame.mod.version", updateVersion)
    end

    return updateInfo
end



function ReloadKeys()

    uiKeys = {}
    uiKeys[#uiKeys+1] = GetString(pathKey.."menu")

    lightKeys = {}
    lightKeys[#lightKeys+1] = GetString(pathKey.."lightMode")
    lightKeys[#lightKeys+1] = GetString(pathKey.."headLight")
    lightKeys[#lightKeys+1] = GetString(pathKey.."lightSignal")
    lightKeys[#lightKeys+1] = GetString(pathKey.."foglight")
    lightKeys[#lightKeys+1] = GetString(pathKey.."warning")
    lightKeys[#lightKeys+1] = GetString(pathKey.."additional")
    lightKeys[#lightKeys+1] = GetString(pathKey.."blinkerL")
    lightKeys[#lightKeys+1] = GetString(pathKey.."blinkerR")
    lightKeys[#lightKeys+1] = GetString(pathKey.."primary")
    lightKeys[#lightKeys+1] = GetString(pathKey.."secondary")
    lightKeys[#lightKeys+1] = GetString(pathKey.."tertiary")
    lightKeys[#lightKeys+1] = GetString(pathKey.."directional")

    honksCtrl = {}
    honksCtrl[#honksCtrl+1] = GetString(pathKey.."siren1")
    honksCtrl[#honksCtrl+1] = GetString(pathKey.."siren2")
    honksCtrl[#honksCtrl+1] = GetString(pathKey.."siren3")
    honksCtrl[#honksCtrl+1] = GetString(pathKey.."horn")
    honksCtrl[#honksCtrl+1] = GetString(pathKey.."sirenhold1")
    honksCtrl[#honksCtrl+1] = GetString(pathKey.."sirenhold2")
    honksCtrl[#honksCtrl+1] = GetString(pathKey.."siren4")

end
